# dynamic_discriminant.praat
# djmw 20050517,20050612

procedure remove2 id1 id2
  select id1
  plus id2
  Remove
endproc

procedure remove1 id
  select id
  Remove
endproc

procedure remove3 id1 id2 id3
  select id1
  plus id2
  plus id3
  Remove
endproc

ml1 = 1
ml2 = 326
mt1 = 327
mt2 = 438
fl1 = 439
fl2 = 574
ft1 = 575
ft2 = 630

datadir$ = "/home/david/tex/thesis/data/"

savedir$ = "/home/david/tex/thesis/anorm/"

#call test_static barks_total_frame123_mf

#call adaptive_fp pols1973

#call adaptive_bf barks_total_frame123_mf

call adaptive_bf_summary barks_total_frame123_mf_meansperspeaker

#call testwithin

procedure get_train_test_fp
  Create TableOfReal (Pols 1973)... n
  Rename... train
  train = selected ("TableOfReal")
  Copy... test
  test = selected ("TableOfReal")
endproc

procedure adaptive_fp name$
  call get_train_test_fp
  call adaptive train test 'name$'
endproc

procedure adaptive_bf name$
  call get_train_test_bf 'name$'
  call adaptive train test 'name$'
endproc

procedure adaptive_bf_summary name$
  call get_train_test_bf_summary 'name$'
  call adaptive train test 'name$'
endproc

procedure get_train_test_bf_summary name$
  Read from file... 'datadir$''name$'.TableOfReal
  t123 = selected ("TableOfReal")
  Rename... t123
  # Extract frame 2
  Extract column ranges... 19:36
  t2 = selected ("TableOfReal")

  Extract row ranges... 6009 : 8078
  Rename... test
  test = selected ("TableOfReal")
  select t2
  Extract row ranges... 1 : 6008
  Rename... train
  train = selected ("TableOfReal")
endproc

procedure adaptive train_id test_id name$

  nprob = 10
  nalpha=10
  dx = 0.05
  dy = 0.05
  repetitions = 10
  result$ = "result"
  Create Matrix... 'result$' -dx/2 (nalpha-1)*0.05+dx/2 nalpha dx 0
     ... 0.4-dy/2 0.4+(nprob-1)*dy+dy/2 nprob dy 0.4 0
  mresult = selected ("Matrix")

  Create TableOfReal... 'result$' nprob*nalpha 3+repetitions
  result = selected ("TableOfReal")
  Set column label (index)... 1 alpha
  Set column label (index)... 2 prob
  Set column label (index)... 3 fcb
  for k to repetitions
    Set column label (index)... 3+k fcm'k'
  endfor

  select train_id
  To Discriminant
  dis = selected ("Discriminant")
  row = 0

  for j to nprob
    prob = 0.4+(j-1)*dy
    for i to nalpha
      alpha = (i-1)*dx
      row += 1
      call adapt dis test alpha prob blocked
      fcb = fc
      select result
      Set value... row 1 alpha
      Set value... row 2 prob
      Set value... row 3 fcb

      for k to repetitions
        select test_id
        Randomize rows
        t2r = selected ("TableOfReal")
        call adapt dis t2r alpha prob mixed
        select result
        Set value... row 3+k fc
        diff = fcb - fc
        select mresult
        value = Matrix_'result$'[j,i]+diff
        Set value... j i value
        call remove1 t2r
      endfor
    endfor
  endfor

  select result
  Write to short text file... 'savedir$''name$'_dynamic_discriminant.TableOfReal

  select mresult
  Formula... self/repetitions
  Write to short text file... 'savedir$''name$'_dynamic_discriminant.Matrix

endproc

procedure test_static name$
  printline -----
  printline
  call readtest 'name$'

  printline ----- COG-corrected
  printline
  call readtest 'name$'_cog_corrected
endproc

procedure readtest name$
  Read from file... 'datadir$''name$'.TableOfReal
  t123 = selected ("TableOfReal")
  Rename... t123

  Read from file... 'datadir$''name$'_meansperspeaker.TableOfReal
  tm123 = selected ("TableOfReal")
  Rename... tm123dordrecht

  Read from file... 'datadir$''name$'_index.TableOfReal
  t123_index = selected ("TableOfReal")
  Rename... t123_index

  Read from file... 'datadir$''name$'_meansperspeaker_index.TableOfReal
  tm123_index = selected ("TableOfReal")
  Rename... tm123_index

  call testdis t123 tm123 t123_index tm123_index
  call remove3 t123 tm123 t123_index tm123_index
endproc  

procedure test dis table
  select dis
  plus table
  To ClassificationTable... y y
  ct = selected ("ClassificationTable")
  To Confusion
  conf = selected ("Confusion")
  fc = Get fraction correct
  call remove2 conf ct
endproc

procedure learntest tl_id tt_id
  select tl_id
  To Discriminant
  dis = selected ("Discriminant")
  call test dis tl_id
  fcl = fc
  call test dis tt_id
  fct = fc
  printline 'tab$'fcl,fct 'fcl','fct'  
  select dis
  Remove
endproc

procedure learntestselecion tl_id tlb tle tt_id ttb tte
  select tl_id
  Extract row ranges... 'tlb':'tle'
  tlt = selected ("TableOfReal")
  select tt_id
  Extract row ranges... 'ttb':'tte'
  ttt = selected ("TableOfReal")
  call learntest tlt ttt
  call remove2 tlt ttt
endproc

procedure read2 name$ index$
   Read from file... 'datadir$''name$'.TableOfReal
   t123 = selected ("TableOfReal")
   Extract column ranges... 19:36
   t2 = selected ("TableOfReal")
   Read from file... 'datadir$''index$'.TableOfReal
   t123_index = selected ("TableOfReal")
endproc

procedure testwithin1 name$ index$
  call read2 'name$' 'index$'
  select t123_index

  iml1 = Get value... ml1 1
  iml2 = Get value... ml2 2
  imt1 = Get value... mt1 1
  imt2 = Get value... mt2 2
  ifl1 = Get value... fl1 1
  ifl2 = Get value... fl2 2
  ift1 = Get value... ft1 1
  ift2 = Get value... ft2 2

  printline 'name$' t2 LEARN 'iml1':'iml2' TEST 'imt1':'imt2'
  call learntestselecion t2 iml1 iml2 t2 imt1 imt2

  printline 'name$' LEARN 'ifl1':'ifl2' TEST 'ift1':'ift2'
  call learntestselecion t2 ifl1 ifl2 t2 ift1 ift2

  printline 'name$' t123 LEARN 'iml1':'iml2' TEST 'imt1':'imt2'
  call learntestselecion t123 iml1 iml2 t123 imt1 imt2

  printline 'name$' LEARN 'ifl1':'ifl2' TEST 'ift1':'ift2'
  call learntestselecion t123 ifl1 ifl2 t123 ift1 ift2

  call remove3 t123 t2 t123_index
endproc

procedure testwithin
  base$ = "barks_total_frame123_mf"
  stressed$ = "barks_total_frame123_mf_stressed"
  
  printline 'newline$'BASE'newline$'
  call testwithin1 'base$' 'base$'_index
  printline 'newline$'BASE (COG)'newline$'
  call testwithin1 'base$'_cog_corrected 'base$'_index
  
  printline 'newline$'BASE_MEANSPERSPEAKER'newline$'
  call testwithin1 'base$'_meansperspeaker 'base$'_meansperspeaker_index
  printline 'newline$'BASE_MEANSPERSPEAKER (COG)'newline$'
  call testwithin1 'base$'_meansperspeaker_cog_corrected 'base$'_meansperspeaker_index
 
  printline 'newline$'STRESSED'newline$'
  call testwithin1 'stressed$' 'stressed$'_index
  printline 'newline$'STRESSED (COG)'newline$'
  call testwithin1 'stressed$'_cog_corrected 'stressed$'_index
  
  printline 'newline$'STRESSED_MEANSPERSPEAKER'newline$'
  call testwithin1 'stressed$'_meansperspeaker 'stressed$'_meansperspeaker_index
  printline 'newline$'STRESSED_MEANSPERSPEAKER (COG)'newline$'
  call testwithin1 'stressed$'_meansperspeaker_cog_corrected 'stressed$'_meansperspeaker_index

endproc



procedure testdis t123_id tm123_id index_id mindex_id

  select index_id
  mla1 = Get value... 1 1
  mla2 = Get value... 1 1



 
  select t123_id
  # Extract frame 2
  Extract column ranges... 19:36
  t2 = selected ("TableOfReal")
  Rename... t2
  
  select tm123_id
  # Extract frame 2
  Extract column ranges... 19:36
  tm2 = selected ("TableOfReal")
  Rename... tm2
  
  printline Train: M-L-A Test: M-T-A
  call split_test t2 1 40468 40469 54357
  call split_test t123_id 1 40468 40469 54357

  printline Train: F-L-A Test: F-T-A
  call split_test t2 54358 71352 71353 78374
  call split_test t123_id 54358 71352 71353 78374
  
  printline Train: M-L-S Test: M-T-S
  call split_test tm2 1 6008 6009 8078
  call split_test tm123_id 1 6008 6009 8078

  printline Train: F-L-S Test: F-T-S
  call split_test tm2 8079 10568 10569 11579
  call split_test tm123_id 8079 10568 10569 11579

  printline Train: M-L-S Test: M-T-A
  select tm2
  Extract row ranges... 1:6008
  learn = selected ("TableOfReal")
  select t2
  Extract row ranges... 1:40468
  test = selected ("TableOfReal")
  call test learn test
  call remove2 learn test

  printline Train: F-L-S Test: F-T-A
  select tm2
  Extract row ranges... 8079:10568
  learn = selected ("TableOfReal")
  select t2
  Extract row ranges... 71353:78374
  test = selected ("TableOfReal")
  call test learn test
  call remove2 learn test


  printline Train: M-L-S Test: M-T-A
  select tm123_id
  Extract row ranges... 1:6008
  learn = selected ("TableOfReal")
  select t123_id
  Extract row ranges... 1:40468
  test = selected ("TableOfReal")
  call test learn test
  call remove2 learn test

  printline Train: F-L-S Test: F-T-A
  select tm123_id
  Extract row ranges... 8079:10568
  learn = selected ("TableOfReal")
  select t123_id
  Extract row ranges... 71353:78374
  test = selected ("TableOfReal")
  call test learn test
  call remove2 learn test
  
endproc

procedure split1 t_id index1 index2
  select t_id
  Extract row ranges... 'index1':'index2'
  ts1 = selected ("TableOfReal")
endproc

procedure split2 table_id index1 index2 index3 index4
  select table_id
  name$ = selected$ ("TableOfReal")
  Extract row ranges... 'index1':'index2'
  ts1 = selected ("TableOfReal")
  namen$=name$+"_1"
  Rename... 'namen$'
  select table_id
  Extract row ranges... 'index3':'index4'
  namen$=name$+"_2"
  Rename... 'namen$'
  ts2 = selected ("TableOfReal")
endproc

procedure test learn_id test_id
  select learn_id
  name1$ = selected$ ("TableOfReal")
  To Discriminant
  dis = selected ("Discriminant")
  select test_id
  name2$ = selected$ ("TableOfReal")
  plus dis
  To ClassificationTable... y y
  ct = selected ("ClassificationTable")
  To Confusion
  conf = selected ("Confusion")
  fc = Get fraction correct
  printline 'name1$' 'name2$' fc='fc'
  call remove3 ct conf dis
endproc

procedure split_test table_id index1 index2 index3 index4
  call split2 table_id index1 index2 index3 index4
  call test ts1 ts2
  call remove2 ts1 ts2
endproc

procedure adapt dis_id t_id alpha prob comment$
  select dis_id
  plus t_id
  To ClassificationTable (dw)... y y alpha prob
  ct = selected ("ClassificationTable")
  tmp = selected ("TableOfReal")
  select ct
  To Confusion
  conf = selected ("Confusion")
  fc = Get fraction correct
  printline alpha='alpha'; prob ='prob' 'comment$': fc='fc'
  call remove3 ct conf tmp
endproc

  

