# pcs_PCA_dynamics.praat
# djmw 20050727

datadir$ = "/home/david/tex/thesis/data/"
savedir$ = "/home/david/tex/thesis/anorm/"

call processdata

procedure processdata
  Read from file... 'datadir$'barks_total_frame123_mf_meansperspeaker.TableOfReal
  fullmf = selected ("TableOfReal")
  Read from file... 'datadir$'barks_total_frame123_mf_meansperspeaker_index.TableOfReal
  index = selected ("TableOfReal")
  # speaker 1-438 male, 439-630 female
  # select 192 males and 192 females
  lowerindexm = Get value... 1 1
  upperindexm= Get value... 192 2
  lowerindexf = Get value... 439 1
  upperindexf = Get value... 630 2
  select fullmf
  Extract row ranges... 'lowerindexm':'upperindexm'
  Rename... m
  m = selected ("TableOfReal")
  To TableOfReal (means by row labels)... n
  mmeans = selected ("TableOfReal")
  select fullmf
  Extract row ranges... 'lowerindexf':'upperindexf'
  Rename... f
  f = selected ("TableOfReal")
  To TableOfReal (means by row labels)... n
  fmeans = selected ("TableOfReal")
  plus mmeans
  Append
  mfmeans = selected ("TableOfReal")
  
  select m
  plus f
  Append
  Rename... mf
  mf = selected ("TableOfReal")
  To PCA
  pca = selected ("PCA")
  plus mfmeans
  To Configuration... 2
  conf_mf = selected ("Configuration")
  Rename... conf_mf
   
  Create TableOfReal... mfc 21 4
  mfc = selected ("TableOfReal")
  Formula... if col < 3 then Configuration_conf_mf[row,col] else
  	... Configuration_conf_mf[row+20,col-2] endif
  for j to 4
    xm'j' = 0
  endfor
  for i to 20
    select conf_mf
	label$ = Get row label... i
	select mfc
	Set row label (index)... i 'label$'
	for j to 4
	    xm'j' += TableOfReal_mfc[i, j]
	endfor
  endfor
  for j to 4
    xm'j' /= 20
	val = xm'j'
	Set value... 21 j val
  endfor
 
  Set row label (index)... 21 m

# split eigenvector in 3 parts to show the similarity between the part better
# One may use Draw rows... to do this
  Create simple Matrix... ev 6 18 0
  ev = selected ("Matrix")
  Rename... ev
  for i to 6
    ei = (i-1) div 3 + 1
    for j to 18
      select pca
      eij = ((i-1) mod 3) * 18 + j
      val = Get eigenvector element... ei eij
      select ev
      Set value... i j val
    endfor
  endfor  
  select mmeans
  plus fmeans
  plus mfmeans
#  plus conf_mf
  Remove
endproc

Erase all
a = 1/2.54
Black
Plain line

# Figure 1

factor = abs((220-150)/(-190 -(-80)))
xwidth = 8
yheight = xwidth * factor
x0 = 1.5
y0 = 1
x1 = x0
x2 = x1 + xwidth
y1 = y0
y2 = y1 + yheight
Select inner viewport... a*x1 a*x2 a*y1 a*y2
Draw inner box
select TableOfReal mfc
Draw vectors... 1 2 3 4 -190 -80 150 220 Line 10 y
Text... TableOfReal_mfc[21,3] Centre TableOfReal_mfc[21,4] Half w
Marks bottom every... 1 10 n y n
Marks left every... 1 10 n y n
Text bottom... n pc1
Text left... y pc2
Text top... n (a) Principal component plane

# Figure 2 

#x2 = x1 + (xwidth-x0)/2
y1 = y2 + 1.5*y0
y2 = y1 + yheight / 2
Select inner viewport... a*x1 a*x2 a*y1 a*y2
select pca
Draw eigenvector... 1 n 0 0 -0.4 0.4 0.00001 . y n
Dotted line
Draw eigenvector... 2 n 0 0 -0.4 0.4 0.00001 . y n
Plain line
Draw inner box
Marks bottom every... 1 1 n y n
One mark left... 0.4 y y n
One mark left... 0 y y y
One mark left... -0.4 y y n
One mark bottom... 1 y n n
One mark bottom... 19 y n y
One mark bottom... 37 y n y
One mark bottom... 54 y n n
Text bottom... y Filter number
Text top... n (b) Eigenvectors 1 and 2

# Figure 3

#x1 = x2 + x0
#x2 = x0 + xwidth
y1 =y2 + 1.5*y0
y2 = y1 + yheight / 2
Select inner viewport... a*x1 a*x2 a*y1 a*y2
select pca
Draw eigenvalues... 0 0 0.4 1 y y 1 + y
Text top... n (c) Eigenvalues
y1 = y0
Select inner viewport... a*x1 a*x2 a*y1 a*y2
call save pcs_PCA_dynamics

procedure save name$
  fname$ = savedir$+name$
  Write to EPS file... 'fname$'.eps
  system epstopdf --outfile='fname$'.pdf 'fname$'.eps
endproc

hoogte = (5.9722818738566765-0.0048118985126865965)/a
breedte = (4.323490813648293-0.007217847769028797)/a
hoogte$ = fixed$(hoogte,1)
breedte$ = fixed$(breedte,1)
printline hoogte x breedte = 'hoogte$' x 'breedte$'
