# compare_f_bf.praat
# djmw 20060301

form Formant analyse displays
  choice Drawing 1
    button Draw formant medians
    button Draw formants medians per vowel
    button Split male/female parts
  choice Gender 3
    button Male
    button Female
    button Both
  choice Formant 3
    button F1
    button F2
    button F3
    button F1+F2
    button F1+F2+F3
  choice Segment 2
    button 1
    button 2
    button 3
    button 1+2+3
  choice Formant_frequency_scale 3
	button Log10
	button Barks
	button Linear
  positive Median_min 0.5
  positive Median_max 2.0
  positive Max_freq1 4000
  positive Max_freq2 1500
endform
# split in male/female parts table_idm/ table_idf
# call table_splitmf

a = 1/2.54
#a=1
include save.praat

logf = 0

if drawing = 1
  .xoffset = 0
  width = 6*a
  height = 15*a
  Font size... 10
  Black
  max_freq = max_freq1
  if gender = 1
    call draw_formant_medians_mf /home/david/tex/thesis/data/analyse_f_m.TableOfReal 0
    .ext$ = "m"
  elsif gender = 2
    call draw_formant_medians_mf /home/david/tex/thesis/data/analyse_f_f.TableOfReal 0
    .ext$ = "f"
  elsif gender = 3
    .xoffset = width
    call draw_formant_medians_mf /home/david/tex/thesis/data/analyse_f_m.TableOfReal 0
    max_freq = max_freq2
    call draw_formant_medians_mf /home/david/tex/thesis/data/analyse_f_f.TableOfReal .xoffset
    .ext$ = "mf"
  endif
  Select outer viewport... 0 width+.xoffset 0 height
  call save formant_medians_'.ext$'
elsif drawing = 2
  call draw_formants_medians_pervowel_mf gender formant 3
elsif drawing = 3
  call table_splitmf
  select table_id
  Remove
endif

procedure draw_formants_medians_pervowel_mf .gender .iformant .iframe
  if .gender = 1 or .gender = 3
    Read from file... /home/david/tex/thesis/data/analyse_f_m.TableOfReal
    .tableid1 = selected ("TableOfReal")
    .tableid = .tableid1
  endif
  if .gender = 2 or .gender = 3
    Read from file... /home/david/tex/thesis/data/analyse_f_f.TableOfReal
    .tableid2 = selected ("TableOfReal")
    .tableid = .tableid2
    if .gender = 3
      plus .tableid1
      Append
      .tableid3 = selected ("TableOfReal")
      select .tableid1
      plus .tableid
      Remove
      .tableid = .tableid3
    endif
  endif
  select .tableid
  if .iformant >= 1 and .iformant <= 3  
    Extract columns where... (col-1) mod 3 + 1 = .iformant
    texttop$ = "F'.iformant'"
  elsif .iformant = 4
    Extract columns where... col mod 3 = 1 or col mod 3 = 2
    texttop$ = "F12"
  elsif .iformant = 5
    Extract columns where... 1
    texttop$ = "F123"
  endif
  .tmp_id = selected ("TableOfReal")
  call draw_formants_medians_pervowel .tmp_id formants_medians_pervowel_m_f texttop$
  select .tmp_id
  Remove
  select .tableid
#  Remove
endproc


procedure draw_formants_medians_pervowel .tor save$ .texttop$
  Erase all
  width = 6*a
  height = 10*a
  Font size... 6
  Black
  nx = 4
  ny = 5
  dx = width / nx
  dy = height / ny
  select .tor
  Extract row labels as Strings
  .str = selected ("Strings")
  To StringsIndex
  .sind = selected ("StringsIndex")
  nclass = Get number of classes
  for iclass to nclass
    select .sind
    label$ = Get class label... iclass
    select .tor
    Extract rows where label... "is equal to" 'label$'
    Rename... 'label$'
    .tmp = selected ("TableOfReal")
    To TableOfReal (medians by row labels)... y
    Rename... medians
    .tmpm = selected ("TableOfReal")
    select .tmp
    Formula... self[row,col]/TableOfReal_medians[row,col]
    Formula... if self < median_min then median_min else if self>median_max then median_max else self fi fi
    call draw_vowel_medians .tmp 'label$' iclass .texttop$
    select .tmpm
    plus .tmp
    Remove
  endfor
  select .str
  plus .sind
  Remove
  Select outer viewport... 0 width 0 height
  call save 'save$'_'texttop$'
endproc

procedure draw_vowel_medians .tor .label$ .ivowel .texttop$
  iy = floor ((.ivowel-1)/4) + 1
  ix = (.ivowel-1) mod 4 + 1
  vx1 = (ix-1)*dx
  vx2 = vx1 + dx
  vy1 = (iy-1)*dy
  vy2 = vy1 + dy
  Select outer viewport... vx1 vx2 vy1 vy2
  select .tor
  To Matrix
  .m = selected ("Matrix")
  Draw distribution... 0 0 0 0 median_min median_max 40 0 0 y
  Marks bottom every... 1 0.2 n y n
  One mark bottom... 1 y n y
  Text top... n 'texttop$' ('.label$')
  select .m
  Remove
endproc

procedure draw_formant_medians_mf file$ .xoffset
  Read from file... 'file$'
  tableofreal_id = selected ("TableOfReal")
  if formant_frequency_scale = 1
    Formula... if self > 0 then log10(self) else self fi
  elsif formant_frequency_scale = 2
    Formula... if self > 0 then hertzToBark(self) else self fi
  endif
  if .xoffset = 0
    Erase all
  endif
  call draw_formant_medians tableofreal_id .xoffset

  select tableofreal_id
  Remove
endproc

procedure draw_formant_medians .formants .xoffset
  if logf=1
    Formula... if self>0 then log10(self) else self fi
  endif
  To TableOfReal (medians by row labels)... yes

  Rename... medians
  .medians = selected ("TableOfReal")
  select .formants
  Formula... self/TableOfReal_medians[row,col]
  To Matrix
  .matrix = selected ("Matrix")
  Font size... 10
  Black
  dy = height / 3
  vx1 = .xoffset
  vx2 = vx1 + width
  vy2 = 0
  # draw fi_2 (center part)
  it = 2
  for iformant to 3
    vy1 = vy2
    vy2 = vy1 + dy
    Select outer viewport... vx1 vx2 vy1 vy2
    .hr = (it-1)*3+iformant
    Draw distribution... .hr-0.5 .hr+0.5 0 0 median_min median_max 100 0 max_freq y
    Marks bottom every... 1 0.2 n y n
    One mark bottom... 1 y n y
    Text top... n F__'iformant'_
  endfor
endproc
  

# tableofreal with bf and f + extra last column
procedure table_to_tableofreal_fbf .table_id
  select .table_id
  Down to TableOfReal... vowel
  .tmp = selected ("TableOfReal")
  # tableofreal has one column less!
  Extract column ranges... 13:66 76:84
  tableofreal_id = selected ("TableOfReal")
  Formula... if self = undefined then 0 else self fi
  .ncols = Get number of columns
  .ncols += 1
  Insert column (index)... .ncols
  Set column label (index)... .ncols select
  select .tmp
  Remove
endproc

# split in male/female parts
procedure table_splitmf
  Read from file... /home/david/TIMIT/dr0/analyse.Table
  table_id = selected ("Table")
  select table_id
  Extract rows where column (text)... sex "is equal to" m
  table_idm =  selected ("Table")
  call table_to_tableofreal_fbf table_idm
  select tableofreal_id
  Write to short text file... /home/david/tex/thesis/data/analyse_bff_m.TableOfReal
  Extract column ranges... 55:63
  Write to short text file... /home/david/tex/thesis/data/analyse_f_m.TableOfReal

  select table_id
  Extract rows where column (text)... sex "is equal to" f
  table_idf =  selected ("Table")
  call table_to_tableofreal_fbf table_idf
  select tableofreal_id
  Write to short text file... /home/david/tex/thesis/data/analyse_bff_f.TableOfReal
  Extract column ranges... 55:63
  Write to short text file... /home/david/tex/thesis/data/analyse_f_f.TableOfReal
  
endproc
