# select_on_medians.praat
# djmw 20060326

# output results of select_on_medians.praat

datadir$ = "/home/david/tex/thesis/discussion/"

call put_latex_tables cca_analysis_results_linear

call put_latex_tables cca_analysis_results_log

procedure put_latex_tables .file$
  Read from file... 'datadir$''.file$'.TableOfReal
  Rename... results
  .tor = selected ("TableOfReal")
  .nrows = 6

  printline ..... '.file$' ......
  printline \toprule
  printline Sex & $d$ & Data (\%) & $F_1$ & $F_2$ & $F_3$ & $F123_1$ & $F123_2$ & $F123_3$ & $R_F$\\
  printline \midrule
  for .j to 2
    .ntotal = TableOfReal_results[.j*6,1]
    
    for .i to .nrows
      .irow = (.j-1)*6+.i
      col1$ = Get row label... .irow
      col2$ = fixed$ (.i * 0.1, 1)
      col3$ = fixed$ (100*TableOfReal_results[.irow,1]/.ntotal, 1)
      if .i = .nrows
        col2$ = "-"
      endif
      col4$ = fixed$ (TableOfReal_results[.irow,4], 2)
      col5$ = fixed$ (TableOfReal_results[.irow,5], 2)
      col6$ = fixed$ (TableOfReal_results[.irow,6], 2)
      col7$ = fixed$ (TableOfReal_results[.irow,7], 2)
      col8$ = fixed$ (TableOfReal_results[.irow,8], 2)
      col9$ = fixed$ (TableOfReal_results[.irow,9], 2)
      col10$ = fixed$ (TableOfReal_results[.irow,22], 2)
      .string$ = ""
      for .k to 9
        col$ = col'.k'$
        .string$ = .string$ + col'.k'$ + " & "
      endfor
      .string$ = .string$ + col10$ + "\\"
      printline '.string$'
    endfor
    if .j = 1 
      printline \midrule
    endif
  endfor
  printline \bottomrule
endproc

  
