#formant_normalizations.praat
# djmw 20050202

Create TableOfReal (Pols 1973)... no
Rename... m
m = selected("TableOfReal")

# identity
call norm 1 m self;lin

# log scale
call norm 2 m log10(self)

# Bark scale
call norm 3 m hertzToBark(self)

# mel scale
call norm 4 m hertzToMel(self)

# ERB scale
call norm 5 m hertzToErb(self)

# Weenink w.r.t. to uniform tubel 0.17 m
call norm 6 m log10(self/((2*col-1)*500))

call norm 7 m log10(self) / log10(TableOfReal_m[1]*TableOfReal_m[2]*TableOfReal_m[3]) /3

call norm 8 m log10(self/((2*col-1)*500))/ log10(TableOfReal_m[1]*TableOfReal_m[2]*TableOfReal_m[3]) /3

call norm 9 m log10(self/((2*col-1)*500))/ log10(TableOfReal_m[1]*TableOfReal_m[2]) /2

# Sussman 1986
call  norm 10 m log10(self/((TableOfReal_m[1]+TableOfReal_m[2]+TableOfReal_m[3]) /3))

call  norm 11 m if col=1 then log10(self/125) else log10(self[col]/TableOfReal_m[col-1]) fi

call average1 m 50 12 0 0
call  norm 12 preprocessed self;centred+lin

call average1 m 50 12 1 0
call  norm 13 preprocessed self;std+lin

call average1 m 50 12 0 1
call  norm 14 preprocessed self;centred+log

call average1 m 50 12 1 1
call  norm 15 preprocessed self;std+log

procedure norm norm table_id formula$
  select table_id
  Copy... m2
  m2 = selected("TableOfReal")
  Formula... 'formula$'
  call get_perc 'norm' 'm2'
  pc$ = percent$ (pc,2)
  printline norm'norm' correct = 'pc$' 'formula$'
endproc

procedure get_perc norm table_id
  select table_id
  To Discriminant
  d = selected ("Discriminant")
  plus table_id
  To ClassificationTable... y y
  c = selected ("ClassificationTable")
  To Confusion
  cf = selected ("Confusion")
  pc = Get fraction correct
  select cf
  plus c
  plus d
  plus table_id
  Remove
endproc

procedure average1 table_id ns nv proc logvals
  Create TableOfReal... smeans ns 3*2
  means = selected ("TableOfReal")
  for isp to ns
    select table_id
    rb = (isp-1)*nv + 1
    re = rb + nv - 1
    select table_id
    Extract row ranges... 'rb':'re'
    m'isp' = selected ("TableOfReal")
    if logvals = 1
      Formula... log10(self)
    endif
    for ifor to 3
      fm'ifor' = Get column mean (index)... ifor
      fs'ifor' = Get column stdev (index)... ifor
      stdev = if proc = 0 then 1 else fs'ifor' fi
      Formula... if col=ifor then (self-fm'ifor')/stdev else self fi
    endfor
    select means
    for ifor to 3
      Set value... isp ifor fm'ifor'
      Set value... isp 3+ifor fs'ifor'
    endfor
  endfor
  select m1
  for isp from 2 to ns
    plus m'isp'
  endfor
  Append
  preprocessed = selected ("TableOfReal")
  select m1
  for isp from 2 to ns
    plus m'isp'
  endfor
  Remove
endproc
  
