# bandfilter_cogperspeaker_correction.praat

# 20050315 djmw
# 20050511 djmw Latest modification

form COG per speaker correction
  comment Default extension is .TableOfReal
  word Table barks_total_frame2_mf
  word Index barks_total_frame123_mf_index
#  natural Begin 1
#  natural End 630
  word Resultnamepart result
endform

ext$ = ".TableOfReal"
datadir$ = "/home/david/tex/thesis/data/"

procedure read name1$ name2$
  file1$ = datadir$ + name1$ + ext$
  file2$ = datadir$ + name2$+ ext$

  Read from file... 'file1$'
  table1 = selected ("TableOfReal")
  Read from file... 'file2$'
  speakers = selected ("TableOfReal")
endproc

call read 'table$' 'index$'

call cog_correction table1 speakers

procedure cog_correction table_id table_index_id
  
  select table_index_id
  table_index$ = selected$ ("TableOfReal")
  nrows = Get number of rows

  select table_id
  Copy... tc
  tc = selected ("TableOfReal")

  # Get means per speaker in expanded table
  ii = 1
  for i to nrows
    if i > TableOfReal_'table_index$'[ii,2]
      ii += 1
    endif
    label$ = "'ii'"
    Set row label (index)... i 'label$'
  endfor

  To TableOfReal (means by row labels)... y
  Rename... perspeaker

  # Get means per speaker group in expanded table

  select table_id
  Copy... tmf
  for i to nrows
    if i <= TableOfReal_index[438,2]
      label$ = "m"
    else
      label$ = "f"
    endif
    Set row label (index)... i 'label$'
  endfor

  To TableOfReal (means by row labels)... y
  Rename... diff

  # Get the dif
  Formula... self - TableOfReal_perspeaker[]

  # Correct by the diff

  select table_id
  Copy... diffcorrected
  Formula... self + TableOfReal_diff[]
  tdiff = selected ("TableOfReal")
endproc
