# male-female-classification.praat
# 20050316 djmw
# 20060824 Latest modification

savedir$ = "/home/david/tex/thesis/nn-bias2/"
include /home/david/tex/praat_procedures.praat

Read from file... /home/david/tex/thesis/data/barks_total_frame2_mf_meansperspeaker.TableOfReal
Copy... mf
mf = selected ("TableOfReal")

nrows = Get number of rows
for i to nrows
  if i < 8079
   label$ = "m"
  else
   label$ = "f"
  endif
  Set row label (index)... i 'label$'
endfor

To Discriminant
dis = selected ("Discriminant")

procedure classify train_id test_id
  select train_id
  To Discriminant
  dis = selected ("Discriminant")

  select dis
  plus test_id
  To ClassificationTable... y y
  ct = selected ("ClassificationTable")
  To Confusion
  fc1 = Get fraction correct
  plus ct
  Remove

  select dis
  plus test_id
  To ClassificationTable... y n
  ct = selected ("ClassificationTable")
  To Confusion
  fc2 = Get fraction correct
  plus ct
  Remove

  select dis
  plus test_id
  To ClassificationTable... n n
  ct = selected ("ClassificationTable")
  To Confusion
  fc3 = Get fraction correct
  plus ct
  Remove

  select dis
  plus test_id
  To ClassificationTable... n y
  ct = selected ("ClassificationTable")
  To Confusion
  fc4 = Get fraction correct
  plus ct
  Remove

  printline +pool+apriori 'fc1'
  printline +pool-apriori 'fc2'
  printline -pool-apriori 'fc3'
  printline -pool+apriori 'fc4' 
endproc

printline
printline ....... train == test 
call classify mf mf

select dis

call vp_init 10 5 1 1 1
call vp_next
Draw eigenvector... 1 n 0 0 -1 1 1 + y n
call eigenvector_decoration  
#call save male-female-classification

procedure eigenvector_decoration texttop$
  Draw inner box
  Marks bottom every... 1 1 n y n
  One mark left... 1 y y n
  One mark left... 0 y y y
  One mark left... -1 y y n
  Text bottom... y Filter number
  Text top... n 'texttop$'
  One mark bottom... 1 y n n
  One mark bottom... 18 y n n
endproc

# again but separate test and train sets

select mf
Extract row ranges... 1 : 6008 8079 : 10568
train = selected ("TableOfReal")
select mf
Extract row ranges... 6009 : 8078 10569 : 11579
test = selected ("TableOfReal")
printline ...... train != test 
call classify train test

# test telephone range

select mf
Extract column ranges... 3:16
mf2 =  selected ("TableOfReal")
printline ...... train == test filters 3:16
call classify mf2 mf2


select train
Extract column ranges... 3:16
train2 =  selected ("TableOfReal")
select test
Extract column ranges... 3:16
test2 =  selected ("TableOfReal")

printline ...... train != test 3:16
call classify train2 test2

Create TableOfReal... bf3-10 6 18
res = selected ("TableOfReal")

for k to 3
for i to 18
  select train
  if k=1
    rowb = 1
    range$="'i':18"
  elsif k=2
    rowb = 3
    range$="1:'i'"
  else
    rowb = 5
    range$="'i':'i'"
  endif
  Extract column ranges... 'range$'
  train'i' =  selected ("TableOfReal")
  To Discriminant
  dis = selected ("Discriminant")
  select test
  Extract column ranges... 'range$'
  test'i' =  selected ("TableOfReal")
  for j from 0 to 1
    select dis
    plus test'i'
    To ClassificationTable... 'j' n
    ct = selected ("ClassificationTable")
    To Confusion
    fc'j' = Get fraction correct
    plus ct
    Remove
  endfor
  select res
  Set value... rowb i fc0
  Set value... rowb+1 i fc1
  printline 'i' ('range$'): 'fc1' 'fc0' (+-pool)
  select dis
  plus train'i'
  plus test'i'
  Remove
endfor
endfor 
call vp_init 12 12 1 2 1
call vp_next

select res
for i to 18
  Set column label (index)... i 'i'
endfor

intergroup = 2
Draw rows as histogram... "1 2" 0 0 0.5 1 1 intergroup 0 "0.8 1" y
call histogram_decoration Start filter number
Text top... n (a)

call vp_next
Draw rows as histogram... "3 4" 0 0 0.5 1 1 intergroup 0 "0.8 1" y
call histogram_decoration End filter number
Text top... n (b)

call save male-female-classification-numberoffilters

procedure histogram_decoration textbottom$
  nr = 2
  nc = 18
  hoffset = 1
  interbar = 0
  width = 1/(nc*nr+2*hoffset+(nc-1)*intergroup+nc*(nr-1)*interbar)

  dx =(intergroup+nr+(nr-1)*interbar)*width
  x = hoffset*width+(2-1)*(1+interbar)*width
  for i to 18
    One mark bottom... x n y n
    x += dx
  endfor
  for i to 4
    One mark left... 0.5+i*0.1 y y y
  endfor
  Text bottom... y 'textbottom$'
  Text left... y Fraction correct
endproc

select res
Set row label (index)... 1 i:18-p
Set row label (index)... 2 i:18+p
Set row label (index)... 3 1:i-p
Set row label (index)... 4 1:i+p
Set row label (index)... 5 i-p
Set row label (index)... 6 i+p


Write to short text file... 'savedir$'male-female-classification-numberoffilters.TableOfReal