# timit_vowels_bf_mf.praat

Font size... 10
Black
a = 1/2.54
datadir$ = "/home/david/tex/thesis/data/"
savedir$ = "/home/david/tex/thesis/nn-bias2/"

Create TableOfReal... sequence 1 20
Formula... col
seq = selected ("TableOfReal")


Read from file... 'datadir$'barks_total_frame2_mf_meansperspeaker.TableOfReal
mf = selected ("TableOfReal")
Read from file... 'datadir$'barks_total_frame2_mf_meansperspeaker_index.TableOfReal
index = selected ("TableOfReal")

# speaker 1-438 male, 439-630 female
lowerindexm = Get value... 1 1
upperindexm= Get value... 438 2
lowerindexf = Get value... 439 1
upperindexf= Get value... 630 2


select mf
Extract row ranges... 'lowerindexm':'upperindexm'
Rename... m
m = selected ("TableOfReal")
To TableOfReal (means by row labels)... n
mm = selected ("TableOfReal")
To Matrix
matm = selected ("Matrix")

select mf
Extract row ranges... 'lowerindexf':'upperindexf'
Rename... f
f = selected ("TableOfReal")
To TableOfReal (means by row labels)... n
fm = selected ("TableOfReal")
To Matrix
matf = selected ("Matrix")

procedure matrix_decorate text$
  Draw inner box
  Marks bottom every... 1 1 n y n
  Marks left every... 1 10 n y n
  Text... 16 Centre 70 Half 'text$'
endproc

Erase all
x0 = 2
y0 = 2
dx = 2.25
dy = 2
y2 = y0
for i to 20
  if ((i-1) mod 4) = 0
    x1 = x0
    y1 = y2
    y2 = y1 + dy
  endif
  x2 = x1 + dx
  Select inner viewport... a*x1 a*x2 a*y1 a*y2
  select seq
  vindex = TableOfReal_sequence[1,i]
  Plain line
  select matm
  Draw rows... 0 0 vindex-0.5 vindex+0.5 0 80
  Dotted line
  select matf
  Draw rows... 0 0 vindex-0.5 vindex+0.5 0 80
  Plain line
  select mm
  label$ = Get row label... vindex
  call matrix_decorate 'label$'
  x1 = x2
endfor

Select inner viewport... a*x0 a*x2 a*y0 a*y2

call save timit_vowels_bf_mf
# width: (4.914041994750655-0.20406824146981617)*2.54 = 11.96
# heigth = (5.1132983377077865-0.3985126859142607)*2.54 = 11.98
procedure save name$
  fname$ = savedir$+name$
  Write to EPS file... 'fname$'.eps
  system epstopdf --outfile='fname$'.pdf 'fname$'.eps
endproc

